unit main;

interface
uses c6502,snd,classes,commdlg,windows,sysutils,inifiles,
     messages,mmsystem,nes,nes_ppu,nes_mmc,fastdib;

procedure ReadConfig;
procedure WriteConfig;
procedure checkfordirs;
function about_proc(Wnd,uMsg,wParam,lParam:Longint):Longint; stdcall;
function rominfo_proc(Wnd,uMsg,wParam,lParam:Longint):Longint; stdcall;

var
BackBuffer:TFastDIB;
wndc,wndc2,wndc3:twndclass; //class of our window
_hinst:HINST;    //Application instance
main_hwnd:hwnd;  //handle of our main window
debug_hwnd:hwnd; //=====
msg:tmsg;        //message window recived
main_l,main_t,
main_w,main_h:integer;//Dimensions
debug_l,debug_t,
debug_w,debug_h:integer;//Dimensions
ds:array[1..7]of hwnd;
debugtexts:array[1..7]of string = (
 'I/O Read     :','I/O Write    :',
 'MMC debug    :','PPU debug    :',
 'Input Status :','Fps          :',
 'St1          :');
dwtime:dword = 0;
dwFrameTime:dword = 0;
dwFrameCount:dword = 0;
dwFrames:dword;
procedure init;
procedure deinit;
procedure run_app;
procedure fps;
function printf(p:string;no:integer):integer;
implementation

function printf(p:string;no:integer):integer;
begin
setwindowtext(ds[no],pchar(debugtexts[no]+' '+p));
result := no;
end;


procedure ReadConfig;
begin


    { Joypad 1 }
      BUTTON1_UP := inif.ReadInteger('Ultee','Pad1 up',VK_UP);
      BUTTON1_DOWN := inif.ReadInteger('Ultee','Pad1 down',VK_DOWN);
      BUTTON1_LEFT := inif.ReadInteger('Ultee','Pad1 left',VK_LEFT);
      BUTTON1_RIGHT := inif.ReadInteger('Ultee','Pad1 right',VK_RIGHT);
      BUTTON1_A := inif.ReadInteger('Ultee','Pad1 A',ord('N'));
      BUTTON1_B := inif.ReadInteger('Ultee','Pad1 B',ord('M'));
      BUTTON1_START := inif.ReadInteger('Ultee','Pad1 start',VK_RETURN);
      BUTTON1_SELECT := inif.ReadInteger('Ultee','Pad1 select',VK_SPACE);
    { Joypad 2 }
      BUTTON2_UP := inif.ReadInteger('Ultee','Pad2 up',ord('E'));
      BUTTON2_DOWN := inif.ReadInteger('Ultee','Pad2 down',ord('X'));
      BUTTON2_LEFT := inif.ReadInteger('Ultee','Pad2 left',ord('S'));
      BUTTON2_RIGHT := inif.ReadInteger('Ultee','Pad2 right',ord('D'));
      BUTTON2_A := inif.ReadInteger('Ultee','Pad2 A',ord('G'));
      BUTTON2_B := inif.ReadInteger('Ultee','Pad2 B',ord('H'));
      BUTTON2_START := inif.ReadInteger('Ultee','Pad2 start',ord('T'));
      BUTTON2_SELECT := inif.ReadInteger('Ultee','Pad2 select',ord('Y'));
end; { ReadConfig }

procedure WriteConfig;
var
  i : integer;
begin

    { NES }
    inif.WriteInteger('Ultee','FrameRate', FrameRate);
    { Joypad 1 }
    inif.WriteInteger('Ultee','Pad1 up', BUTTON1_UP);
    inif.WriteInteger('Ultee','Pad1 down', BUTTON1_DOWN);
    inif.WriteInteger('Ultee','Pad1 left', BUTTON1_LEFT);
    inif.WriteInteger('Ultee','Pad1 right', BUTTON1_RIGHT);
    inif.WriteInteger('Ultee','Pad1 A', BUTTON1_A);
    inif.WriteInteger('Ultee','Pad1 B', BUTTON1_B);
    inif.WriteInteger('Ultee','Pad1 start', BUTTON1_START);
    inif.WriteInteger('Ultee','Pad1 select', BUTTON1_SELECT);
    { Joypad 2 }
    inif.WriteInteger('Ultee','Pad2 up', BUTTON2_UP);
    inif.WriteInteger('Ultee','Pad2 down', BUTTON2_DOWN);
    inif.WriteInteger('Ultee','Pad2 left', BUTTON2_LEFT);
    inif.WriteInteger('Ultee','Pad2 right', BUTTON2_RIGHT);
    inif.WriteInteger('Ultee','Pad2 A', BUTTON2_A);
    inif.WriteInteger('Ultee','Pad2 B', BUTTON2_B);
    inif.WriteInteger('Ultee','Pad2 start', BUTTON2_START);
    inif.WriteInteger('Ultee','Pad2 select', BUTTON2_SELECT);

end; { WriteConfig }



procedure openfile_proc;

  function AllocFilterStr(const S: string): string;
  var
    P: PChar;
  begin
    Result := '';
    if S <> '' then
    begin
      Result := S + #0;  // double null terminators
      P := AnsiStrScan(PChar(Result), '|');
      while P <> nil do
      begin
        P^ := #0;
        Inc(P);
        P := AnsiStrScan(P, '|');
      end;
    end;
  end;

var
ofn:TOpenFilename;
tmpfilter:string;
gszFileName:array[0..255]of char;
begin
tmpfilter := 'iNes File Format|*.nes';
       // gszFileName := nil;
        gszFileName[0] := #0;
        ofn.lStructSize := sizeof(TOPENFILENAME);
        ofn.hwndOwner := main_hwnd;
        ofn.hInstance := _hinst;
        ofn.lpstrTitle := 'Load Nes Rom';
        ofn.lpstrFilter := pchar(AllocFilterStr(tmpfilter));
        ofn.lpstrCustomFilter := nil;
        ofn.nMaxCustFilter := 0;
        ofn.nFilterIndex := 0;
        ofn.lpstrFile := gszFileName;
        ofn.nMaxFile := 256;
        ofn.lpstrFileTitle := nil;
        ofn.nMaxFileTitle := 0;
        ofn.lpstrInitialDir := nil;
        ofn.Flags := OFN_FILEMUSTEXIST or OFN_PATHMUSTEXIST or OFN_HIDEREADONLY;
        ofn.nFileOffset := 0;
        ofn.nFileExtension := 0;
        ofn.lpstrDefExt := 'nes';
        ofn.lCustData := 0;
        ofn.lpfnHook := nil;
        ofn.lpTemplateName := nil;



if getopenfilename(ofn) then
begin
//Open_output;
Runm(gszFileName);
end;
end;


function DirectoryExists(const Name: string): Boolean;
var
  Code: Integer;
begin
  Code := GetFileAttributes(PChar(Name));
  Result := (Code <> -1) and (FILE_ATTRIBUTE_DIRECTORY and Code <> 0);
end;

procedure checkfordirs;
begin
if not DirectoryExists(extractfilepath(ParamStr(0))+'snapshots\') then
begin
createdir(extractfilepath(ParamStr(0))+'snapshots\');
end;
{if not DirectoryExists(extractfilepath(Application.exename)+'\saves') then
begin
createdir(extractfilepath(Application.exename)+'\saves');
end;}
end;



procedure Savesnap;
label ggg;
var d:integer;
tmp:string;
begin

d := 0;
ggg : d := d + 1;

tmp := Copy(RomFilename, 1, Pos('.', RomFilename)-1);
{tmpb := Tfastrgb.Create
flop( );}
if fileexists(extractfilepath(ParamStr(0))+'snapshots\'+tmp+'_ss'+inttostr(d)+'.bmp') then
begin
goto ggg;
end
else
begin
backbuffer.SaveToFile(extractfilepath(ParamStr(0))+'snapshots\'+tmp+'_ss'+inttostr(d)+'.bmp');
end;

end;


function main_proc(hwn,msg,wpr,lpr:longint):longint;stdcall;
var dc:integer;
   rc:trect;
   b:hbrush;
   wid:integer;
   vkey :integer;
   ps:Paintstruct;
begin
rc.left := 0;
rc.top := 0;
rc.right := 320;
rc.bottom := 240;
result:=defwindowproc(hwn,msg,wpr,lpr);
if msg=WM_COMMAND then
begin
wid := loword(wpr);
if wid = 40001 then
begin
openfile_proc;
end;

if wid = 32002 then
begin
resetnes;
reset6502(cpu);
trashnes;
end;

if wid = 40003 then
begin
if Rom_On then freerom;
msg := WM_DESTROY;
end;


if wid = 40004 then
begin
if romfilename = '' then exit;
Rom_On := false;
reset6502(cpu);
ResetNes;
Rom_On := true;
Run6502(cpu);
end;


if wid = 40005 then
begin
if romfilename = '' then exit;

if Rom_On = false then
begin
SetWindowText(40005,'Pause');
Rom_On := true;
run6502(cpu);
end
else
begin
SetWindowText(40005,'Resume');
Rom_On := false;
end;

end;


if wid = 40007 then
begin
if romfilename = '' then exit;
Save_state;
end;

if wid = 40008 then
begin
if romfilename = '' then exit;
Load_state;
end;


if wid = 32000 then
begin
if Rom_On = true then
begin
Rom_On := false;
EnableWindow(main_hwnd,false);
DialogBox(_hinst,MAKEINTRESOURCE(103),main_hwnd,@rominfo_proc);
end;
end;

if wid = 40009 then
begin
MessageBox(main_hwnd,'Soon','Options',MB_OK);
end;


if wid = 40010 then
begin
//MessageBox(main_hwnd,'Ultee Windowed v0.1.2 By Vincent','About',MB_OK);

EnableWindow(main_hwnd,false);
if Rom_On = true then
begin
Rom_On := false;
end;
DialogBox(_hinst,MAKEINTRESOURCE(100),main_hwnd,@about_proc);
//showwindow(about_hwnd,SW_SHOW);
end;


end;

if msg=WM_MOVE then
begin
    main_l := LOWORD(lpr);
    main_t := HIWORD(lpr);
end;

if msg=WM_PAINT then
begin
BeginPaint(hwn,ps);
BackBuffer.Draw(ps.hdc,0,0);
endPaint(hwn,ps);
end;

if msg=WM_KEYDOWN then
begin
vkey := wpr;


if vkey = VK_F6 then
begin
Save_state;
end;

if vkey = VK_F9 then
begin
Load_state;
end;

if vkey = VK_F5 then
begin
Savesnap;
end;

if vkey = 187 then
begin
Rom_On := false;
if  cpu.Iperiod >= 250 then exit;
inc(cpu.IPeriod,2);
setwindowtext(main_hwnd,pchar('Speed: '+inttostr(cpu.IPeriod)));
Rom_On := true;
run6502(cpu);
end;

if vkey = 189 then
begin
Rom_On := false;
if  cpu.Iperiod <= 10 then exit;
dec(cpu.IPeriod,2);
setwindowtext(main_hwnd,pchar('Speed: '+inttostr(cpu.IPeriod)));
Rom_On := true;
run6502(cpu);
end;

if vkey = ord('1') then
begin
if showbg = false then showbg := true else showbg := false;
end;

if vkey = ord('2') then
begin
if showsp = false then showsp := true else showsp := false;
end;


if vkey = ord('5') then
begin
Set_pal(0);
end;

if vkey = ord('6') then
begin
Set_pal(1);
end;

if vkey = ord('7') then
begin
Set_pal(2);
end;
end;

if msg = wM_keyup then
begin
setwindowtext(main_hwnd,'Ultee');
end;


if msg=WM_DESTROY then
begin
TrashSound;
    deinit;
end;
end;

procedure init;
begin
inif := tinifile.create('Ultee.ini');
main_w := 260;
main_h := 282;
debug_w := 260;
debug_h := 202;
main_l := inif.readinteger('Ultee','Left',90);
main_t := inif.readinteger('Ultee','Top',90);
debug_l := inif.readinteger('Debug','Left',main_l+debug_w);
debug_t := inif.readinteger('Debug','Top',main_t);
end;

procedure deinit;
begin
writeconfig;
inif.writeinteger('Ultee','Left',main_l);
inif.writeinteger('Ultee','Top',main_t);
inif.writeinteger('Debug','Left',debug_l);
inif.writeinteger('Debug','Top',debug_t);
inif.free;
backbuffer.free;
halt(1);
end;



function debug_proc(hwn,msg,wpr,lpr:longint):longint;stdcall;
var dc:integer;
   rc:trect;
   b:hbrush;
   wid:integer;
   vkey :integer;
begin
result:=defwindowproc(hwn,msg,wpr,lpr);

if msg=WM_MOVE then
begin
    debug_l := LOWORD(lpr);
    debug_t := HIWORD(lpr);
end;

end;


function rominfo_proc(Wnd,uMsg,wParam,lParam:Longint):Longint; stdcall;
procedure closeit;
begin
    EnableWindow(main_hwnd,true);
    SetForegroundWindow(main_hwnd);
    EndDialog(wnd,0);
    if romfilename <> '' then
    begin
    Rom_On := true;
    run6502(cpu);
end;
end;
var
ps: TPaintStruct;
wID:integer;
wh:integer;
d1,d2,d3,d4,d5,d6,d7,d8,d9:integer;
begin
  case uMsg of
  WM_INITDIALOG:
  begin
  d1 := getdlgitem(wnd,7);
  d2 := getdlgitem(wnd,8);
  d3 := getdlgitem(wnd,9);
  d4 := getdlgitem(wnd,10);
  d5 := getdlgitem(wnd,11);
  d6 := getdlgitem(wnd,12);
  d7 := getdlgitem(wnd,13);
  d8 := getdlgitem(wnd,65535);
setwindowtext(d8,pchar(Romfilename));
if mmctype = 0 then
setwindowtext(d3,'Not using any memory mapper')
else
setwindowtext(d3,pchar('Using memory mapper '+inttostr(mmctype)));

setwindowtext(d1,pchar('Rom Size :'+format('%d Kb', [Ord(RomHeader.PRGROM) * 16])));

setwindowtext(d2,pchar('VRom Size :'+format('%d Kb', [Ord(RomHeader.CHRRAM) * 8])));
if (Mirroring <> 0) then setwindowtext(d5,'Mirroring : Yes') else
setwindowtext(d5,'Mirroring : No');

if (ROMType and ROM_WRAM) <> 0 then setwindowtext(d6,'Battery : Yes') else
setwindowtext(d6,'Battery : No');

if (ROMType and ROM_TRAINER) <> 0 then setwindowtext(d7,'Trainer : Yes') else
setwindowtext(d7,'Trainer : No');

if (ROMType and ROM_FOUR) <> 0 then setwindowtext(d4,'FourScreen : Yes') else
setwindowtext(d4,'Four Screen : No');

  end;
  WM_COMMAND:
  begin
  wID := LOWORD(wParam);
  if wid = 3000 then
  begin
closeit;
  end;
  end;
  WM_DESTROY:
    begin
closeit;

    end;
  end;

  Result:=0;//DefWindowProc(Wnd,uMsg,wParam,lParam);
end;


{}

function about_proc(Wnd,uMsg,wParam,lParam:Longint):Longint; stdcall;
procedure closeit;
begin
    if romfilename <> '' then
    begin
    Rom_On := true;
    run6502(cpu);
    end;
    EnableWindow(main_hwnd,true);
    SetForegroundWindow(main_hwnd);
    EndDialog(wnd,0);
end;
var
wid : integer;
begin
  case uMsg of
  WM_COMMAND:
  begin
  wID := LOWORD(wParam);
  if wid = 1000 then
  begin
  closeit;
  end;
  end;

  WM_CLOSE:
    begin
  closeit;
    end;
  end;

  Result:=0;//DefWindowProc(Wnd,uMsg,wParam,lParam);
end;



procedure create_windows;
var
Font:hFont;
begin
_hinst:=getmodulehandle(nil);
with wndc do begin
  style:=CS_HREDRAW or CS_VREDRAW;
  lpfnwndproc:=@main_proc;
  hinstance:=_hinst;
  hicon :=loadicon(_hinst,'MAINICON');
  hbrbackground:=7;
  lpszclassname:='Ultee Window Class';
  wndc.lpszMenuName := 'Ultee Window Menu';
  hcursor:=loadcursor(0,IDC_ARROW);
  end;

registerclass(wndc);
main_hwnd:=createwindowex(WS_EX_APPWINDOW,
  'Ultee Window Class',
  'Ultee',
  WS_SYSMENU or WS_MINIMIZEBOX,
  main_l,main_t,
  main_w,
  main_h,
   0,loadmenu(_hinst,'101'),_hinst,nil);
updatewindow(main_hwnd);

  with wndc2 do begin
  style:=CS_HREDRAW or CS_VREDRAW;
  lpfnwndproc:=@debug_proc;
  hinstance:=_hinst;
  hicon :=loadicon(_hinst,nil);
  hbrbackground:=color_btnface+1;
  lpszclassname:='Debug Window Class';
  hcursor:=loadcursor(0,IDC_ARROW);
  end;


registerclass(wndc2);
debug_hwnd:=createwindowex(WS_EX_APPWINDOW,
  'Debug Window Class',
  'Debug Window',
  WS_SYSMENU or WS_MINIMIZEBOX,
  debug_l,debug_t,
  debug_w,
  debug_h,
   0,0,_hinst,nil);
  ds[1]:= createwindow('STATIC','I/O Read     :', WS_VISIBLE or WS_CHILD or SS_LEFT,0,3,190,15,debug_hwnd,0,_hinst,nil);
  ds[2]:= createwindow('STATIC','I/O Write    :', WS_VISIBLE or WS_CHILD or SS_LEFT,0,18,190,15,debug_hwnd,0,_hinst,nil);
  ds[3]:= createwindow('STATIC','MMC debug    :', WS_VISIBLE or WS_CHILD or SS_LEFT,0,33,190,15,debug_hwnd,0,_hinst,nil);
  ds[4]:= createwindow('STATIC','PPU debug    :', WS_VISIBLE or WS_CHILD or SS_LEFT,0,48,190,15,debug_hwnd,0,_hinst,nil);
  ds[5]:= createwindow('STATIC','Input Status :', WS_VISIBLE or WS_CHILD or SS_LEFT,0,63,190,15,debug_hwnd,0,_hinst,nil);
  ds[6]:= createwindow('STATIC','Fps          :', WS_VISIBLE or WS_CHILD or SS_LEFT,0,78,190,15,debug_hwnd,0,_hinst,nil);
  ds[7]:= createwindow('STATIC','St1          :', WS_VISIBLE or WS_CHILD or SS_LEFT,0,93,190,15,debug_hwnd,0,_hinst,nil);

  Font := CreateFont(-11, 0, 0, 0, 400, 0, 0, 0, DEFAULT_CHARSET,
                      OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY,
                      DEFAULT_PITCH or FF_DONTCARE, 'MS Sans Serif');
  if Font <> 0 then
  begin
    SendMessage(ds[1], WM_SETFONT, Font, 0);
    SendMessage(ds[2], WM_SETFONT, Font, 0);
    SendMessage(ds[3], WM_SETFONT, Font, 0);
    SendMessage(ds[4], WM_SETFONT, Font, 0);
    SendMessage(ds[5], WM_SETFONT, Font, 0);
    SendMessage(ds[6], WM_SETFONT, Font, 0);
    SendMessage(ds[7], WM_SETFONT, Font, 0);
  end;
  updatewindow(debug_hwnd);

end;

procedure fps;
begin
asm inc dwFrameCount end;
dwTime := timeGetTime - dwFrameTime;
if ( dwTime >= 1000 ) then
begin
dwFrames := ( dwFrameCount*1000 ) div dwTime;
dwFrameTime := timeGetTime;
dwFrameCount := 0;
end;
//if dwframes > 60 then SleepEx(1,false);
//setwindowtext(main_hwnd,pchar('Ultee, Fps: '+inttostr(dwFrames)));
printf(inttostr(dwFrames),6);
end;

procedure run_app;
var GotMsg:boolean;
begin
init;
create_windows;
BackBuffer := TFastDIB.Create;
BackBuffer.SetSize(320,240,8,0);
//BackBuffer.PixelFormat := pf8bit;
//BackBuffer.width := 320;
//BackBuffer.height := 240;
init_e;

showwindow(main_hwnd,SW_SHOW);
  while true do
  begin
    GotMsg:=PeekMessage(Msg,0,0,0,PM_REMOVE);
    if GotMsg then DispatchMessage(Msg) else
    begin
  //  if aboutbox then drawfire;
    end;
  end;

end;

end.
